Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Botan::ESP_Padding Class Referencefinal

`#include <mode_pad.h>`

Inheritance diagram for Botan::ESP_Padding:

## Public Member Functions
void | add_padding (secure_vector< uint8_t > &buffer, size_t final_block_bytes, size_t block_size) const override
std::string | name () const override
size_t | unpad (const uint8_t[], size_t) const override
bool | valid_blocksize (size_t bs) const override

## Detailed Description

ESP Padding (RFC 4304)

Definition at line 119 of file mode_pad.h.

## Member Function Documentation

void Botan::ESP_Padding::add_padding | ( | secure_vector< uint8_t > & | buffer,
|  | size_t | final_block_bytes,
|  | size_t | block_size
| ) |  | const
| override virtual

Add padding bytes to buffer.

Parameters

  buffer | data to pad
  final_block_bytes | size of the final block in bytes
  block_size | size of each block in bytes

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 159 of file mode_pad.cpp.

162 {
163 uint8_t pad_value = 0x01;
164
165 for(size_t i = last_byte_pos; i < block_size; ++i)
166 {
167 buffer.push_back(pad_value++);
168 }
169 }

std::string Botan::ESP_Padding::name | ( |  | ) | const
| inline override virtual

Returns
  name of the mode

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 130 of file mode_pad.h.

130 { return "ESP"; }

size_t Botan::ESP_Padding::unpad | ( | const uint8_t | block[],
|  | size_t | size
| ) |  | const
| override virtual

Remove padding bytes from block

Parameters

  block | the last block
  size | the size of the block in bytes

Returns
  number of padding bytes

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 174 of file mode_pad.cpp.

References Botan::CT::conditional_copy_mem(), Botan::CT::expand_mask(), Botan::CT::poison(), and Botan::CT::unpoison().

175 {
176 CT::poison(block,size);
177
178 const size_t last_byte = block[size-1];
179 size_t bad_input = 0;
180 bad_input |= CT::expand_mask(last_byte > size);
181
182 size_t pad_pos = size - last_byte;
183 size_t i = size - 1;
184 while(i)
185 {
186 bad_input |= ~CT::is_equal<size_t>(size_t(block[i-1]),size_t(block[i])-1) & CT::expand_mask(i > pad_pos);
187 --i;
188 }
189 CT::conditional_copy_mem(bad_input,&pad_pos,&size,&pad_pos,1);
190 CT::unpoison(block, size);
191 CT::unpoison(pad_pos);
192 return pad_pos;
193 }
Botan::CT::conditional_copy_mem
void conditional_copy_mem(T value, T *to, const T *from0, const T *from1, size_t elems)
Definition: ct_utils.h:138
Botan::CT::poison
void poison(const T *p, size_t n)
Definition: ct_utils.h:46
Botan::CT::expand_mask
T expand_mask(T x)
Definition: ct_utils.h:86
Botan::CT::unpoison
void unpoison(const T *p, size_t n)
Definition: ct_utils.h:57

bool Botan::ESP_Padding::valid_blocksize | ( | size_t | block_size | ) | const
| inline override virtual

Parameters

  block_size | of the cipher

Returns
  valid block size for this padding mode

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 128 of file mode_pad.h.

128 { return (bs > 0); }

The documentation for this class was generated from the following files:

- src/lib/modes/mode_pad/mode_pad.h
- src/lib/modes/mode_pad/mode_pad.cpp